Package org.apache.tapestry5.internal.parser

## Interface ComponentTemplate

- All Known Implementing Classes:
    `ComponentTemplateImpl`

      public interface ComponentTemplate

  A parsed component template, containing all the tokens parsed from the template.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.Map<java.lang.String,​Location>` | `getComponentIds()` | Identifies `StartComponentToken`s with a non-blank id, mapping the id to its location (within the template).
    `java.util.Set<java.lang.String>` | `getExtensionPointIds()` | Returns the extension point ids, including both <t:extension-point> and <t:replace>.
    `java.util.List<TemplateToken>` | `getExtensionPointTokens​(java.lang.String extensionPointId)` | Returns a list of tokens associated with an extension point, or null if this template neither defines the extension point nor overrides it.
    `Resource` | `getResource()` | Returns the resource that was parsed to form the template.
    `java.util.List<TemplateToken>` | `getTokens()` | Returns a list of tokens that were parsed from the template.
    `boolean` | `isExtension()` | Returns true if this component template is an extension of its parent class' template.
    `boolean` | `isMissing()` | Returns true if no template could be found for the component.
    `boolean` | `usesStrictMixinParameters()` | Indicates whether lax (the old default) or strict (the new default) mixin parameters are used.

- - ### Method Detail

    - #### isMissing

          boolean isMissing()

      Returns true if no template could be found for the component.

    - #### isExtension

          boolean isExtension()

      Returns true if this component template is an extension of its parent class' template.
      Since:
        5.1.0.1

    - #### usesStrictMixinParameters

          boolean usesStrictMixinParameters()

      Indicates whether lax (the old default) or strict (the new default) mixin parameters are used. In strict mode, introduced with the 5.4 template DTD, mixin parameters must be qualified with the mixin name. In prior releases, Tapestry would attempt a search for a fit, and this causes ambiguities that can't be addressed.
      Returns:
        true if a 5.4 or later DTD
      Since:
        5.4

    - #### getExtensionPointTokens

          java.util.List<TemplateToken> getExtensionPointTokens​(java.lang.String extensionPointId)

      Returns a list of tokens associated with an extension point, or null if this template neither defines the extension point nor overrides it.
      Parameters:
        `extensionPointId` -
      Returns:
        list of tokens provided in this template, or null
      Since:
        5.1.0.1

    - #### getExtensionPointIds

          java.util.Set<java.lang.String> getExtensionPointIds()

      Returns the extension point ids, including both <t:extension-point> and <t:replace>.
      Returns:
        set of extension point ids.
      Since:
        5.8.5

    - #### getResource

          Resource getResource()

      Returns the resource that was parsed to form the template.

    - #### getTokens

          java.util.List<TemplateToken> getTokens()

      Returns a list of tokens that were parsed from the template. The caller should not modify this list.

    - #### getComponentIds

          java.util.Map<java.lang.String,​Location> getComponentIds()

      Identifies `StartComponentToken`s with a non-blank id, mapping the id to its location (within the template). This is used to report unmatched ids (where the component, or its super-classes, do not define an embedded component).
      See Also:
        `(used to define an embedded component)`